﻿Imports System.Runtime.InteropServices
Imports System
Imports System.Text

' Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
' or the page: 
' http://cognaxon.com/index.php?page=wsqlib_NETnotes
' FAQ (Frequently Asked Questions)
' for .NET developers on using WSQ image library


Public Class Form1


    Private WSQ_library_native_methods As WSQImageLibraryNativeMethods32
    Private input_data_stream As Byte()
    Private input_data_stream2 As Byte()
    Private output_data_stream As Byte()
    Private output_data_stream2 As Byte()
    Private pwidth As Int32
    Private pheight As Int32
    Private ppi As Int32
    Private comment_text As String
    Private bitrate As Double
    Private w As Int32
    Private h As Int32
	Private utf8 As New UTF8Encoding



    'To call functions from WSQ_library.dll
    'you can use the methods from wrapper class WSQImageLibraryNativeMethods32
    'or you can use function prototypes provided below 

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function _CreateBMPFromFile(ByVal FileName As Byte()) As IntPtr
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function _SaveBMPToFile(ByVal hBitmap As IntPtr, ByVal FileName As Byte(), ByVal ifiletype As Short) As Int32
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub _RegisterWSQ()
    End Sub

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub _SetShowFilePropertiesDialog(ByVal file_properties_dialog As Integer)
    End Sub

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub _ShowFileConverter()
    End Sub

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function _ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function

    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function _SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, ByVal FileName As Byte()) As Int32
    End Function


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        comment_text = String.Empty 'need to initialize comment_text in order to avoid crashing

        WSQ_library_native_methods = New WSQImageLibraryNativeMethods32

    End Sub

    Private Sub ButtonOpen_Click(sender As Object, e As EventArgs) Handles ButtonOpen.Click

        Static hbitmap As IntPtr = IntPtr.Zero

        OpenFileDialog1.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp|" & _
  "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|" & _
  "Windows bitmaps (*.bmp)|*.bmp|" & _
  "Macintosh TIFF images (*.tiff)|*.tiff|" & _
  "PC TIFF images (*.tif)|*.tif|" & _
  "JPG images (*.jpg)|*.jpg|" & _
  "JPEG-2000 Part-1 (*.jp2)|*.jp2|" & _
  "JPEG-2000 Code Stream (*.jpc)|*.jpc|" & _
  "JPE images (*.jpe)|*.jpe|" & _
  "JPEG images (*.jpeg)|*.jpeg|" & _
  "Portable network graphic images (*.png)|*.png|" & _
  "Compuserve Graphic Interchange Format(*.gif)|*gif|" & _
  "Paintshop Pro images (*.psp)|*.psp|" & _
  "JFIF images (*.jfif)|*.jfif|" & _
  "Run length encoded Windows bitmaps (*.rle)|*.rle|" & _
  "Device independant Windows bitmaps (*.dib)|*.dib|" & _
  "Truevision images (*.win)|*.win|" & _
  "Truevision images (*.vst)|*.vst|" & _
  "Truevision images (*.vda)|*.vda|" & _
  "Truevision images (*.tga)|*.tga|" & _
  "Truevision images (*.icb)|*.icb|" & _
  "GFI fax images (*.fax)|*.fax|" & _
  "Encapsulated Postscript images (*.eps)|*.eps|" & _
  "ZSoft Paintbrush images (*.pcx)|*.pcx|" & _
  "ZSoft Paintbrush images (*.pcc)|*.pcc|" & _
  "Word 5.x screen capture images (*.scr)|*.scr|" & _
  "Alias/Wavefront images (*.rpf)|*.rpf|" & _
  "Alias/Wavefront images (*.rla)|*.rla|" & _
  "SGI true color images (*.sgi)|*.sgi|" & _
  "SGI true color images with alpha (*.rgba)|*.rgba|" & _
  "SGI true color images (*.rgb)|*.rgb|" & _
  "SGI black/white images (*.bw)|*.bw|" & _
  "Photoshop images (*.psd)|*.psd|" & _
  "Photoshop images (*.pdd)|*.pdd|" & _
  "Portable pixel map images (*.ppm)|*.ppm|" & _
  "Portable gray map images (*.pgm)|*.pgm|" & _
  "Portable bitmap images (*.pbm)|*.pbm|" & _
  "Autodesk images (*.cel)|*.cel|" & _
  "Autodesk images (*.pic)|*.pic|" & _
  "Kodak Photo-CD images (*.pcd)|*.pcd|" & _
  "Dr. Halo images (*.cut)|*.cut|" & _
  "Amiga Bitmap Graphic (8 bits)|*.iff|" & _
  "Windows icons (*.ico)|*.ico|" & _
  "Windows metafiles (*.wmf)|*.wmf|" & _
  "Windows enhanced meta files (*.emf)|*.emf"

        OpenFileDialog1.FilterIndex = 1
        OpenFileDialog1.FileName = ""

        If (OpenFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'hbitmap = _CreateBMPFromFile(utf8.GetBytes(OpenFileDialog1.FileName))
        hbitmap = WSQ_library_native_methods.pCreateBMPFromFile(OpenFileDialog1.FileName)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        h = OutputPicture.Image.Height
        w = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, w, h)

        ButtonSave.Enabled = True

    End Sub

    Private Sub ButtonSave_Click(sender As Object, e As EventArgs) Handles ButtonSave.Click

        Dim iResult As Short

        ' Set filters.
        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq|" & _
"Windows BMP (*.bmp)|*.bmp|" & _
"TIFF Files (*.tif)|*.tif|" & _
"PNG Files (*.png)|*.png|" & _
"JPEG Files (*.jpg)|*.jpg|" & _
"Targa Files (*.tga)|*.tga|" & _
"SGI Files (*.rgb)|*.rgb|" & _
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" & _
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" & _
"PBM - Portable Bitmap Format (*.pbm)|*.pbm|" & _
"PGM - Portable Graymap Format (*.pgm)|*.pgm|" & _
"PPM - Portable Pixmap Format (*.ppm)|*.ppm"


        ' Specify default filter.
        SaveFileDialog1.FilterIndex = 1
        SaveFileDialog1.FileName = ""


        If (SaveFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        '_SetShowFilePropertiesDialog(1)
        WSQ_library_native_methods.pSetShowFilePropertiesDialog(1)

        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'iResult = _SaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), utf8.GetBytes(SaveFileDialog1.FileName), SaveFileDialog1.FilterIndex)
        iResult = WSQ_library_native_methods.pSaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

        'Dim objBitmap As Bitmap
        'objBitmap = OutputPicture.Image
        'iResult = _SaveBMPToFile(objBitmap.GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

    End Sub

    Private Sub ButtonRegister_Click(sender As Object, e As EventArgs) Handles ButtonRegister.Click

        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        '_RegisterWSQ()
        WSQ_library_native_methods.pRegisterWSQ()

    End Sub

    Private Sub buttonWSQtoStream_Click(sender As Object, e As EventArgs) Handles buttonWSQtoStream.Click

        Static hbitmap As IntPtr = IntPtr.Zero

        Dim OpenFileDialog1 As OpenFileDialog = New OpenFileDialog
        OpenFileDialog1.Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq"
        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog <> DialogResult.OK) Then
            Exit Sub
        End If

        Dim fInfo As IO.FileInfo = New IO.FileInfo(OpenFileDialog1.FileName)
        Dim input_stream_length As Long = fInfo.Length
        Dim fStream As IO.FileStream = New IO.FileStream(OpenFileDialog1.FileName, IO.FileMode.Open, IO.FileAccess.Read)
        Dim br As IO.BinaryReader = New IO.BinaryReader(fStream)

        'force garbage collection of .Net objects:
        'GC.Collect()
        'GC.WaitForPendingFinalizers()
        'GC.Collect()

        input_data_stream = br.ReadBytes(input_stream_length)
        WSQ_library_native_methods.pWSQ_decode_stream(input_data_stream, input_stream_length, output_data_stream,
                pwidth, pheight, ppi, comment_text)

        Dim output_data_stream_length As Integer = pheight * pwidth


        'Converts WSQ compressed byte array into HBITMAP for showing on screen
        hbitmap = WSQ_library_native_methods.pCreateBMPFromWSQByteArray(input_data_stream, input_stream_length)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        h = OutputPicture.Image.Height
        w = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, w, h)

        ' Saves WSQ compressed byte array to an image file.
        'WSQ_library_native_methods.pSaveWSQByteArrayToImageFile(input_data_stream, input_stream_length, "C:\\OutputDirectory\\output.jpg", 5)


        MsgBox("WSQ file was loaded into memory stream and decompressed into another memory stream." & vbCrLf &
            "Now please press button " & ControlChars.Quote & "stream -> WSQ" & ControlChars.Quote &
            " to compress memory stream and save it to file." & vbCrLf &
            "WSQ compressed byte array was converted to HBITMAP for showing on screen.")

        br.Close()
        fStream.Close()

        ButtonStreamToWSQ.Enabled = True

    End Sub

    Private Sub ButtonStreamToWSQ_Click(sender As Object, e As EventArgs) Handles ButtonStreamToWSQ.Click


        Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq"
        SaveFileDialog1.FilterIndex = 1
        If (SaveFileDialog1.ShowDialog <> DialogResult.OK) Then
            Exit Sub
        End If

        bitrate = 0.75
        ppi = 500
        comment_text = "Cognaxon"

        ReDim input_data_stream2(pwidth * pheight)

        Dim row, row2, pixel_number, pixel_number2 As Integer

        'MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
        For y As Integer = 0 To pheight - 1 Step 1
            row = pwidth * y
            row2 = pwidth * (pheight - y - 1)

            For x As Integer = 0 To pwidth - 1 Step 1
                pixel_number = row + x
                pixel_number2 = row2 + (pwidth - x - 1)
                input_data_stream2(pixel_number2) = output_data_stream(pixel_number)
            Next x
        Next y

        Dim compressedLength As Integer

        WSQ_library_native_methods.pWSQ_encode_stream(input_data_stream2, pwidth, pheight,
            bitrate, ppi, comment_text, output_data_stream2, compressedLength)

        Dim fStream As IO.FileStream = New IO.FileStream(SaveFileDialog1.FileName, IO.FileMode.Create)
        Dim bw As IO.BinaryWriter = New IO.BinaryWriter(fStream)

        bw.Write(output_data_stream2)

        bw.Close()
        fStream.Close()

        MsgBox("Memory stream was compressed into another memory stream and saved to WSQ file." & vbCrLf &
           "Now please press button " & ControlChars.Quote & "Open" & ControlChars.Quote &
           ", select the saved file, open it and have a look at the" & vbCrLf &
           "results of memory stream processing. The processed image is mirrored/flipped" & vbCrLf &
           "(UP<->DOWN and LEFT<->RIGHT).")

    End Sub



End Class
